namespace WebAPI.Models;

public class Experience
{
    public Experience(){}
    public Experience(string name,decimal price, Provider provider)
    {
        Name=name;
        Price=(price % 1 < 0.50m) ? (int)Math.Floor(price) : (int)Math.Ceiling(price);
        Provider=provider;
    }
    public int ExperienceId { get; set; }
    public string Name { get; set; }
    public int Price { get; set; }
    public Provider Provider { get; set; }
    public ICollection<Guest> Guests { get; set; } = new List<Guest>(); // N-N relation
    public ICollection<SharedExperience> SharedExperiences { get; set; } = new List<SharedExperience>(); // N-N relation
}
